
let length lst = List.fold_left (fun x y -> x + 1) 0 lst

let reverse lst = List.fold_left (fun x y -> y::x) [] lst

let map f lst = reverse (List.fold_left (fun x y -> (f y)::x) [] lst)

let is_empty lst = List.fold_left (fun x y -> false) true lst

let head lst = 
  List.fold_left (fun x y -> match x with None -> Some y | z -> z) None lst

let tail lst = 
  let r = List.fold_left 
      (fun x y -> match x with None -> Some [] | Some z -> Some (y::z))
      None lst in
  match r with
    None -> None
  | Some z -> Some (reverse z)

